Index: libcfs/include/libcfs/user-prim.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-prim.h,v
retrieving revision 1.8
diff -u -p -r1.8 user-prim.h
--- libcfs/include/libcfs/user-prim.h	1 Dec 2009 02:23:43 -0000	1.8
+++ libcfs/include/libcfs/user-prim.h	1 Jan 2010 20:03:32 -0000
@@ -45,6 +45,9 @@
 #error Do not #include this file directly. #include <libcfs/libcfs.h> instead
 #endif
 
+/** \addtogroup libcfs
+ * @{ */
+
 /* Implementations of portable APIs for liblustre */
 
 /*
@@ -53,8 +56,65 @@
 
 #ifndef __KERNEL__
 
+/* XXX Maxim: it's totally unclear why we need lproc stuff in user-space libcfs
+ * headers. Every libcfs consumer should embrace all lproc-related bits with
+ * #ifdef LPROCFS ... #endif and ensure that LPROCFS undefined in user-space
+ * builds. */
+
+/** \addtogroup libcfs_procfs
+ * @{
+ * \defgroup libcfs_user_procfs Procfs (user-space)
+ * User-space implementation of procfs API
+ *
+ * Libcfs doesn't support manipulating procfs entries and sysctl tables in
+ * user-space. It only provides stubs for some procfs-related types:
+ *
+ * - cfs_proc_dir_entry_t
+ * - cfs_read_proc_t
+ * - cfs_write_proc_t
+ *
+ * and for pseudo-device type and operations:
+ *
+ * - cfs_psdev_t
+ * - cfs_psdev_register
+ * - cfs_psdev_deregister
+ *
+ * Libcfs also abstracts file operations for dealing with /proc entries and /dev
+ * devices from user-space to allow winnt-specific libcfs to implement them in a
+ * subtle way hiding winnt peculiarities from callers (cfs_proc_* primitives).
+ * @{
+ */
 typedef struct proc_dir_entry           cfs_proc_dir_entry_t;
 
+typedef int (cfs_read_proc_t)(char *page, char **start, off_t off,
+                          int count, int *eof, void *data);
+
+struct file; /* forward ref */
+typedef int (cfs_write_proc_t)(struct file *file, const char *buffer,
+                               unsigned long count, void *data);
+
+/* proc interface wrappers for non-win OS */
+#ifndef __WINNT__
+#define cfs_proc_open   open
+#define cfs_proc_mknod  mknod
+#define cfs_proc_ioctl  ioctl
+#define cfs_proc_close  close
+#define cfs_proc_read   read
+#define cfs_proc_write  write
+#define cfs_proc_fopen  fopen
+#define cfs_proc_fclose fclose
+#define cfs_proc_fgets  fgets
+/* !__WINNT__ */
+#endif
+
+/** @} libcfs_user_procfs */
+/** @} libcfs_procfs */
+
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_userspace_synchronization
+ * @{ */
+
 /*
  * Just present a single processor until will add thread support.
  */
@@ -68,8 +128,17 @@ typedef struct proc_dir_entry           
 #define num_possible_cpus() 1
 #endif
 
-/*
- * Wait Queue. 
+/**
+ * \defgroup libcfs_userspace_waitqueue Wait queues
+ * wait-queue (user-space, single-threaded)
+ *
+ * The most part of primitives is no-ops. The only exceptions are
+ * cfs_waitq_wait and cfs_waitq_timedwait that try to relinquish CPU
+ * calling global cfs_wait_handler_t callback (see
+ * \ref libcfs_userspace_completion for details).
+ *
+ * \see \ref libcfs_waitqueue for general description
+ * @{
  */
 
 typedef struct cfs_waitlink {
@@ -81,7 +150,7 @@ typedef struct cfs_waitq {
         struct list_head sleepers;
 } cfs_waitq_t;
 
-/* XXX: need to replace wake_up with cfs_waitq_signal() */
+/** XXX: need to replace wake_up with cfs_waitq_signal() */
 #define wake_up(q) cfs_waitq_signal(q)
 
 /*
@@ -93,36 +162,50 @@ typedef long cfs_task_state_t;
 #define CFS_TASK_UNINT          (1)
 #define CFS_TASK_RUNNING        (2)
 
-
-/* 
- * Lproc
- */
-typedef int (cfs_read_proc_t)(char *page, char **start, off_t off,
-                          int count, int *eof, void *data);
-
-struct file; /* forward ref */
-typedef int (cfs_write_proc_t)(struct file *file, const char *buffer,
-                               unsigned long count, void *data);
-
-/*
- * Signal
+/** @} libcfs_userspace_waitqueue */
+/** @} libcfs_userspace_synchronization */
+/** @} libcfs_synchronization */
+
+/** \addtogroup libcfs_signal
+ * @{
+ * \defgroup libcfs_userspace_signal Signal (user-space)
+ * Implementation of user-space signal API is based on sigprocmask(2) and
+ * sigpending(2), daemonization primitives are no-ops.
+ * @{
  */
 typedef sigset_t                        cfs_sigset_t;
 
-/*
- * Timer
- */
+#define cfs_sigfillset(l) do {}         while (0)
+#define cfs_recalc_sigpending(l)        do {} while (0)
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_timer
+ * @{
+ *
+ * \defgroup libcfs_userspace_timer Timer (user-space)
+ * Timer (user-space, single-threaded)
+ *
+ * Be careful: cfs_timer_t looks sound and API does something but it's
+ * illusion - nobody ever calls timer callback! Regard it as no-op
+ * implementation.
+ * @{
+ */
 typedef struct {
         struct list_head tl_list;
         void (*function)(ulong_ptr_t unused);
         ulong_ptr_t data;
         long expires;
 } cfs_timer_t;
-
+/** @} */
+/** @} */
 
 #define in_interrupt()    (0)
 
+/** \addtogroup libcfs_ioctl
+ * @{
+ * \addtogroup libcfs_userspace_ioctl
+ * @{ */
 typedef void cfs_psdev_t;
 
 static inline int cfs_psdev_register(cfs_psdev_t *foo)
@@ -134,10 +217,10 @@ static inline int cfs_psdev_deregister(c
 {
         return 0;
 }
+/** @} */
+/** @} */
 
 #define cfs_lock_kernel()               do {} while (0)
-#define cfs_sigfillset(l) do {}         while (0)
-#define cfs_recalc_sigpending(l)        do {} while (0)
 #define cfs_kernel_thread(l,m,n)        LBUG()
 #define cfs_kthread_run(fn,d,fmt,...)   LBUG()
 
@@ -148,23 +231,58 @@ int cfs_create_thread(cfs_thread_t func,
 #define cfs_create_thread(l,m) LBUG()
 #endif
 
+/** \addtogroup libcfs_curproc
+ * @{
+ * \addtogroup libcfs_userspace_curproc
+ * @{ */
 uid_t cfs_curproc_uid(void);
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_mem
+ * @{
+ * \addtogroup libcfs_user_mem
+ * @{ */
 #define LIBCFS_REALLOC(ptr, size) realloc(ptr, size)
+/** @} */
+/** @} */
 
 #define cfs_online_cpus() sysconf(_SC_NPROCESSORS_ONLN)
 
 // static inline void local_irq_save(unsigned long flag) {return;}
 // static inline void local_irq_restore(unsigned long flag) {return;}
 
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_stack_trace
+ * @{
+ * \defgroup libcfs_stack_trace_userspace Stack-tracing (user-space)
+ * User-space implementation of stack-tracing
+ * @{
+ */
+
 enum {
+        /** maximum # frames in stack-trace */
         CFS_STACK_TRACE_DEPTH = 16
 };
 
+/**
+ * User-space version of stack-trace structure.
+ * Plain array of opaque pointers to stack-trace frames.
+ */
 struct cfs_stack_trace {
         void *frame[CFS_STACK_TRACE_DEPTH];
 };
 
+/** @} libcfs_stack_trace_userspace */
+/** @} libcfs_stack_trace */
+/** @} libcfs_debug */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_userspace_misc
+ * @{ */
+
 /*
  * arithmetic
  */
@@ -199,23 +317,14 @@ static inline void libcfs_arch_cleanup(v
 /* __WINNT__ */
 #endif
 
-/* proc interface wrappers for non-win OS */
-#ifndef __WINNT__
-#define cfs_proc_open   open
-#define cfs_proc_mknod  mknod
-#define cfs_proc_ioctl  ioctl
-#define cfs_proc_close  close
-#define cfs_proc_read   read
-#define cfs_proc_write  write
-#define cfs_proc_fopen  fopen
-#define cfs_proc_fclose fclose
-#define cfs_proc_fgets  fgets
-/* !__WINNT__ */
-#endif
+/** @} libcfs_userspace_misc */
+/** @} libcfs_misc */
 
 /* !__KERNEL__ */
 #endif
 
+/** @} libcfs */
+
 /* __LIBCFS_USER_PRIM_H__ */
 #endif
 /*
Index: libcfs/include/libcfs/user-tcpip.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-tcpip.h,v
retrieving revision 1.5
diff -u -p -r1.5 user-tcpip.h
--- libcfs/include/libcfs/user-tcpip.h	3 Feb 2009 13:43:17 -0000	1.5
+++ libcfs/include/libcfs/user-tcpip.h	1 Jan 2010 20:03:32 -0000
@@ -45,10 +45,25 @@
 
 #include <sys/uio.h>
 
+/**
+ * \addtogroup libcfs
+ * @{
+ *
+ * \addtogroup libcfs_net
+ * @{
+ *
+ * \defgroup libcfs_user_net Network API (user-space)
+ *
+ * See \ref libcfs_net for generic description.
+ * @{
+ */
+
 /*
  * Functions to get network interfaces info
  */
 
+/* XXX Maxim: libcfs_sock_ioctl is not part of libcfs API. Move its
+ * prototype to user-tcpip.c */
 int libcfs_sock_ioctl(int cmd, unsigned long arg);
 int libcfs_ipif_query (char *name, int *up, __u32 *ip);
 void libcfs_ipif_free_enumeration (char **names, int n);
@@ -58,10 +73,13 @@ int libcfs_ipif_enumerate (char ***names
  * Network function used by user-land lnet acceptor
  */
 
+/** This is how user-space libcfs abstracts socket file descriptor */
 typedef struct cfs_socket {
+        /** file descriptor acquired with socket(2) */
         int s_fd;
 } cfs_socket_t;
 
+/** usocklnd needs it to poll(2) */
 #define LIBCFS_SOCK2FD(sock) ((sock)->s_fd)
 
 int libcfs_sock_listen(cfs_socket_t **sockp, __u32 ip, int port, int backlog);
@@ -111,6 +129,9 @@ int libcfs_sock_create(cfs_socket_t **so
 #error "Undefined byteorder??"
 #endif /* __LITTLE_ENDIAN */
 
+/** @} libcfs_user_net */
+/** @} libcfs_net */
+/** @} libcfs */
 #endif /* !__KERNEL__ */
 
 #endif
Index: libcfs/include/libcfs/user-time.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-time.h,v
retrieving revision 1.5
diff -u -p -r1.5 user-time.h
--- libcfs/include/libcfs/user-time.h	7 Oct 2008 04:14:07 -0000	1.5
+++ libcfs/include/libcfs/user-time.h	1 Jan 2010 20:03:32 -0000
@@ -47,9 +47,16 @@
 #error Do not #include this file directly. #include <libcfs/libcfs.h> instead
 #endif
 
-/* Portable time API */
+/** \addtogroup libcfs
+ * @{ */
 
-/*
+/** \addtogroup libcfs_time
+ * @{ */
+
+/**
+ * \defgroup libcfs_user_time Time (user-space)
+ * Portable time API for user-space
+ *
  * Platform provides three opaque data-types:
  *
  *  cfs_time_t        represents point in time. This is internal kernel
@@ -83,7 +90,7 @@
  *
  *  CFS_TIME_FORMAT
  *  CFS_DURATION_FORMAT
- *
+ * @{
  */
 
 #ifndef __KERNEL__
@@ -95,8 +102,11 @@
  * Liblustre. time(2) based implementation.
  */
 
+/** time(2) based implementation */
 typedef time_t cfs_fs_time_t;
+/** time(2) based implementation */
 typedef time_t cfs_time_t;
+/** time(2) based implementation */
 typedef time_t cfs_duration_t;
 
 /* looks like linux */
@@ -192,6 +202,10 @@ static inline int cfs_fs_time_beforeq(cf
 /* !__KERNEL__ */
 #endif
 
+/** @} libcfs_user_time */
+/** @} libcfs_time */
+/** @} libcfs */
+
 /* __LIBCFS_USER_TIME_H__ */
 #endif
 /*
Index: libcfs/include/libcfs/linux/kp30.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/kp30.h,v
retrieving revision 1.15
diff -u -p -r1.15 kp30.h
--- libcfs/include/libcfs/linux/kp30.h	26 Aug 2009 09:41:26 -0000	1.15
+++ libcfs/include/libcfs/linux/kp30.h	1 Jan 2010 20:03:33 -0000
@@ -80,6 +80,9 @@
 
 #include <libcfs/linux/portals_compat25.h>
 
+/** \addtogroup libcfs
+ * @{ */
+
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
 #define schedule_work schedule_task
 #define prepare_work(wq,cb,cbdata)                                            \
@@ -131,6 +134,14 @@ static inline void our_cond_resched(void
 
 #endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0) */
 
+
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_linux_synchronization
+ * @{ */
+
+/** \addtogroup libcfs_linux_spin_locks
+ * @{ */
 #ifdef CONFIG_SMP
 #define LASSERT_SPIN_LOCKED(lock) LASSERT(spin_is_locked(lock))
 #define LINVRNT_SPIN_LOCKED(lock) LINVRNT(spin_is_locked(lock))
@@ -138,6 +149,10 @@ static inline void our_cond_resched(void
 #define LASSERT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #define LINVRNT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #endif
+/** @} libcfs_linux_spin_locks */
+
+/** \defgroup libcfs_linux_semaphore Semaphore
+ * @{ */
 #define LASSERT_SEM_LOCKED(sem) LASSERT(down_trylock(sem) != 0)
 
 #ifdef HAVE_SEM_COUNT_ATOMIC
@@ -145,11 +160,26 @@ static inline void our_cond_resched(void
 #else
 #define SEM_COUNT(sem)          ((sem)->count)
 #endif
+/** @} libcfs_linux_semaphore */
 
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_linux_debug
+ * @{ */
 #define LIBCFS_PANIC(msg)            panic(msg)
+/** @} */
+/** @} */
 
 /* ------------------------------------------------------------------- */
 
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
+
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
 
 #define PORTAL_SYMBOL_REGISTER(x) inter_module_register(#x, THIS_MODULE, &x)
@@ -193,6 +223,9 @@ static inline void our_cond_resched(void
 #endif
 /******************************************************************************/
 
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
+
 #if (__GNUC__)
 /* Use the special GNU C __attribute__ hack to have the compiler check the
  * printf style argument string against the actual argument count and
@@ -205,21 +238,46 @@ static inline void our_cond_resched(void
 
 #endif /* __GNUC__ */
 
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_linux_debug
+ * @{ */
 # define fprintf(a, format, b...) CDEBUG(D_OTHER, format , ## b)
 # define printf(format, b...) CDEBUG(D_OTHER, format , ## b)
+/** @} libcfs_linux_debug */
+/** @} libcfs_debug */
+
+/** \addtogroup libcfs_time
+ * @{
+ * \addtogroup libcfs_linux_time
+ * @{ */
 # define time(a) CURRENT_TIME
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_linux_synchronization
+ * @{ */
 #ifndef num_possible_cpus
 #define num_possible_cpus() NR_CPUS
 #endif
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
+
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
 #define i_size_read(a) ((a)->i_size)
 #endif
 
 
-/******************************************************************************/
-/* Light-weight trace
- * Support for temporary event tracing with minimal Heisenberg effect. */
+/**
+ * \addtogroup libcfs_lwt
+ * @{
+ * \defgroup libcfs_linux_lwt Light-weight tracing (linux-specific)
+ *
+ * Linux implementation of LWT. See \ref libcfs_lwt for general description.
+ * @{
+ */
 #define LWT_SUPPORT  0
 
 #define LWT_MEMORY   (16<<20)
@@ -322,10 +380,23 @@ extern int  lwt_snapshot (cycles_t *now,
 #  define LWT_EVENT(p1,p2,p3,p4)     /* no userland implementation yet */
 # endif /* __KERNEL__ */
 #endif /* LWT_SUPPORT */
+/** @} libcfs_lwt */
+/** @} libcfs_linux_lwt */
 
 /* ------------------------------------------------------------------ */
 
+/** \addtogroup libcfs_ioctl
+ * @{
+ * \addtogroup libcfs_linux_ioctl
+ * @{ */
 #define IOCTL_LIBCFS_TYPE long
+/** @} */
+/** @} */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
 
 #ifdef __CYGWIN__
 # ifndef BITS_PER_LONG
@@ -405,6 +476,14 @@ static inline void sg_set_page(struct sc
 }
 #endif
 
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
+
+/** \addtogroup libcfs_schedule
+ * @{
+ * \defgroup libcfs_linux_schedule Schedule (linux-specific)
+ * @{ */
+
 #ifndef get_cpu
 # ifdef CONFIG_PREEMPT
 #  define cfs_get_cpu()  ({ preempt_disable(); smp_processor_id(); })
@@ -418,4 +497,9 @@ static inline void sg_set_page(struct sc
 # define cfs_put_cpu()   put_cpu()
 #endif /* get_cpu & put_cpu */
 
+/** @} libcfs_linux_schedule */
+/** @} libcfs_schedule */
+
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/linux/libcfs.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/libcfs.h,v
retrieving revision 1.11
diff -u -p -r1.11 libcfs.h
--- libcfs/include/libcfs/linux/libcfs.h	9 Dec 2009 16:18:35 -0000	1.11
+++ libcfs/include/libcfs/linux/libcfs.h	1 Jan 2010 20:03:33 -0000
@@ -62,6 +62,24 @@
 #include <asm/timex.h>
 #include <linux/sched.h> /* THREAD_SIZE */
 
+/** \addtogroup libcfs
+ * @{ */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \defgroup libcfs_linux_debug Debugging (linux-specific, kernel-space)
+ * Linux-specific implementation of Libcfs debug primitives for
+ * in-kernel users.
+ *
+ * On some platforms (e.g. i386) the stack is very limited resource
+ * for kernel threads. Libcfs provides the following primitives to
+ * control its usage:
+ * - CDEBUG_STACK - calculates current depth of stack
+ * - CHECK_STACK - print out warning message if the stack grew higher
+ * than the waterline (3/4 of THREAD_SIZE).
+ * @{
+ */
+
 #define LUSTRE_TRACE_SIZE (THREAD_SIZE >> 5)
 
 #if !defined(__x86_64__)
@@ -75,6 +93,7 @@
                            (THREAD_SIZE - 1)))
 # endif /* __ia64__ */
 
+/** print out warning message if the stack grew high */
 #define __CHECK_STACK(file, func, line)                                 \
 do {                                                                    \
         unsigned long _stack = CDEBUG_STACK();                           \
@@ -94,36 +113,94 @@ do {                                    
 #define CDEBUG_STACK() (0L)
 #endif /* __x86_64__ */
 
-/* initial pid  */
+/** @} libcfs_linux_debug */
+/** @} libcfs_debug */
+
+/* XXX Maxim: We shouldn't duplicate defining LUSTRE_LNET_PID in all
+ * platform-specific libcfs.h headers. Move it to common libcfs.h. */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
+/** initial pid  */
 #define LUSTRE_LNET_PID          12345
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_linux_debug
+ * @{ */
 #define ENTRY_NESTING_SUPPORT (1)
 #define ENTRY_NESTING   do {;} while (0)
 #define EXIT_NESTING   do {;} while (0)
 #define __current_nesting_level() (0)
+/** @} libcfs_debug */
+/** @} libcfs_linux_debug */
+
+/** \addtogroup libcfs_curproc
+ * @{
+ * \addtogroup libcfs_kernel_curproc
+ * @{ */
 
 /**
- * Platform specific declarations for cfs_curproc API (libcfs/curproc.h)
+ * Linux specific declarations for cfs_curproc API (libcfs/curproc.h)
  *
  * Implementation is in linux-curproc.c
  */
+
 #define CFS_CURPROC_COMM_MAX (sizeof ((struct task_struct *)0)->comm)
 
 #include <linux/capability.h>
 typedef kernel_cap_t cfs_kernel_cap_t;
 
-/*
+/** @} libcfs_kernel_curproc */
+/** @} libcfs_curproc */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_stack_trace
+ * @{
+ * \defgroup libcfs_stack_trace_linux Stack-tracing (linux-specific)
+ * Linux-specific implementation of stack-tracing
+ * @{
+ */
+
+/**
  * No stack-back-tracing in Linux for now.
  */
 struct cfs_stack_trace {
 };
 
+/** @} libcfs_stack_trace_linux */
+/** @} libcfs_stack_trace */
+/** @} libcfs_debug */
+
+
+/** \addtogroup libcfs_types
+ * @{
+ *\defgroup libcfs_linux_types Generic types (linux-specific, kernel-space)
+ *
+ * Definitions of some generic types for linux.
+ *
+ * Most generic types and all primitives for swabbing are already
+ * defined in linux system headers. Libcfs only adds definitions for
+ * long and unsigned long integers with size equal to pointer.
+ * @{
+ */
+
 /* long integer with size equal to pointer */
 typedef unsigned long ulong_ptr_t;
 typedef long long_ptr_t;
 
+/** @} libcfs_linux_types */
+/** @} libcfs_types */
+
 #ifndef WITH_WATCHDOG
 #define WITH_WATCHDOG
 #endif
 
+/** @} libcfs */
+
 #endif /* _LINUX_LIBCFS_H */
Index: libcfs/include/libcfs/linux/linux-fs.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-fs.h,v
retrieving revision 1.6
diff -u -p -r1.6 linux-fs.h
--- libcfs/include/libcfs/linux/linux-fs.h	23 Jun 2009 20:59:03 -0000	1.6
+++ libcfs/include/libcfs/linux/linux-fs.h	1 Jan 2010 20:03:33 -0000
@@ -53,6 +53,16 @@
 #include <linux/stat.h>
 #include <linux/mount.h>
 
+/**
+ * \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_fs
+ * @{
+ * \defgroup libcfs_linux_fs File operations for kernel users (linux-specific)
+ * Linux implementation of Libcfs API for manipulating files in kernel
+ * @{
+ */
+
 typedef struct file cfs_file_t;
 typedef struct dentry cfs_dentry_t;
 typedef struct dirent64 cfs_dirent_t;
@@ -90,4 +100,8 @@ ssize_t cfs_user_write (cfs_file_t *filp
 #define CFS_IFTODT(type)           (((type) & S_IFMT) >> CFS_IFSHIFT)
 #define CFS_DTTOIF(dirtype)        ((dirtype) << CFS_IFSHIFT)
 
+/** @} libcfs_linux_fs */
+/** @} libcfs_fs */
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/linux/linux-lock.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-lock.h,v
retrieving revision 1.14
diff -u -p -r1.14 linux-lock.h
--- libcfs/include/libcfs/linux/linux-lock.h	29 Nov 2008 13:12:47 -0000	1.14
+++ libcfs/include/libcfs/linux/linux-lock.h	1 Jan 2010 20:03:33 -0000
@@ -52,16 +52,36 @@
 #include <linux/smp_lock.h>
 #include <linux/mutex.h>
 
-/*
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup libcfs_synchronization Synchronization
+ * Generic synchronization primitives.
+ *
+ * An abstraction layer over platform-specific synchronization
+ * facilities (mutexes, semaphores, spin-locks, etc.) for protection of
+ * critical sections and facilities (like completions and wait-queues)
+ * for reliable event notifications in SMP environment. Atomic types
+ * and primitives are also in this class.
+ * @{
+ */
+
+/**
+ * \defgroup libcfs_linux_synchronization Synchronization (linux-specific)
+ * Linux-specific implementation of general synchronization primitives.
+ *
  * IMPORTANT !!!!!!!!
  *
  * All locks' declaration are not guaranteed to be initialized,
- * Althought some of they are initialized in Linux. All locks
+ * Although some of they are initialized in Linux. All locks
  * declared by CFS_DECL_* should be initialized explicitly.
+ * @{
  */
 
 
-/*
+/**
+ * \defgroup libcfs_linux_spin_locks Spin-locks
  * spin_lock (use Linux kernel's primitives)
  *
  * - spin_lock_init(x)
@@ -73,7 +93,8 @@
  * - spin_unlock_irqrestore(x, f)
  */
 
-/*
+/**
+ * \defgroup libcfs_linux_rw_sema Read-write semaphores
  * rw_semaphore (use Linux kernel's primitives)
  *
  * - init_rwsem(x)
@@ -81,10 +102,13 @@
  * - up_read(x)
  * - down_write(x)
  * - up_write(x)
+ * @{
  */
 #define fini_rwsem(s) do {} while(0)
+/** @} */
 
-/*
+/**
+ * \defgroup libcfs_linux_rw_lock Read-write locks
  * rwlock_t (use Linux kernel's primitives)
  *
  * - rwlock_init(x)
@@ -94,30 +118,37 @@
  * - write_unlock(x)
  */
 
-/*
+/**
+ * \defgroup libcfs_linux_mutex Mutex
  * mutex:
  *
  * - init_mutex(x)
  * - init_mutex_locked(x)
  * - mutex_up(x)
  * - mutex_down(x)
+ *  @{
  */
 #define init_mutex(x)                   init_MUTEX(x)
 #define init_mutex_locked(x)            init_MUTEX_LOCKED(x)
 #define mutex_up(x)                     up(x)
 #define mutex_down(x)                   down(x)
 #define mutex_down_trylock(x)           down_trylock(x)
+/** @} */
 
-/*
+/**
+ * \defgroup libcfs_linux_completion Completion
  * completion (use Linux kernel's primitives)
  *
- * - init_complition(c)
+ * - init_completion(c)
  * - complete(c)
  * - wait_for_completion(c)
  */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
 
+/** \addtogroup libcfs_linux_mutex
+ * @{ */
+
 /**************************************************************************
  *
  * Mutex interface from newer Linux kernels.
@@ -132,7 +163,7 @@ static inline void mutex_destroy(struct 
 {
 }
 
-/*
+/**
  * This is for use in assertions _only_, i.e., this function should always
  * return 1.
  *
@@ -144,8 +175,25 @@ static inline int mutex_is_locked(struct
 {
         return 1;
 }
+/** @} */
 #endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16) */
 
+/**
+ * \defgroup libcfs_linux_lockdep Lockdep
+ * Linux 'Lock-class' validator
+ *
+ * 'Lock-class' validator is complex linux kernel subsystem that
+ * keeps track the sequence of locks acquired to ensure hard- and
+ * soft-irq safety, avoidance of dead-locks and correctness of lock
+ * hierarchies (when nested versions of locks prims are used). See linux
+ * kernel documentation for more details.
+ *
+ * The code below just provides dummy stubs for linux kernels that
+ * doesn't provide 'Lock-class' facility.
+ *
+ * @{
+ */
+
 #ifndef lockdep_set_class
 
 /**************************************************************************
@@ -191,7 +239,12 @@ static inline void lockdep_on(void)
 # define down_write_nested(lock, subclass) down_write(lock)
 #endif
 #endif /* CONFIG_DEBUG_LOCK_ALLOC */
+/** @} libcfs_linux_lockdep */
 
+/**
+ * \addtogroup libcfs_linux_spin_locks
+ * @{
+ */
 
 /*
  * spinlock "implementation"
@@ -204,6 +257,12 @@ typedef spinlock_t cfs_spinlock_t;
 #define cfs_spin_lock_bh(lock)   spin_lock_bh(lock)
 #define cfs_spin_unlock(lock)    spin_unlock(lock)
 #define cfs_spin_unlock_bh(lock) spin_unlock_bh(lock)
+/** @} */
+
+/**
+ * \addtogroup libcfs_linux_rw_lock
+ * @{
+ */
 
 /*
  * rwlock "implementation"
@@ -216,5 +275,10 @@ typedef rwlock_t cfs_rwlock_t;
 #define cfs_read_unlock(lock)      read_unlock(lock)
 #define cfs_write_lock_bh(lock)    write_lock_bh(lock)
 #define cfs_write_unlock_bh(lock)  write_unlock_bh(lock)
+/** @} */
+
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
+/** @} libcfs */
 
 #endif /* __LIBCFS_LINUX_CFS_LOCK_H__ */
Index: libcfs/include/libcfs/linux/linux-mem.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-mem.h,v
retrieving revision 1.7
diff -u -p -r1.7 linux-mem.h
--- libcfs/include/libcfs/linux/linux-mem.h	24 Sep 2009 15:11:09 -0000	1.7
+++ libcfs/include/libcfs/linux/linux-mem.h	1 Jan 2010 20:03:33 -0000
@@ -57,6 +57,22 @@
 # include <linux/mm_inline.h>
 #endif
 
+/**
+ * \addtogroup libcfs
+ * @{
+ *
+ * \addtogroup libcfs_mem
+ * @{
+ *
+ * \defgroup libcfs_kernel_mem Memory Allocations (kernel-space)
+ * Kernel-space implementation of API for memory allocations
+ * @{
+ *
+ * \defgroup libcfs_linux_mem Memory Allocations (kernel-space, linux-specific)
+ * Linux-specific kernel-space implementation of API for memory allocations
+ * @{
+ */
+
 typedef struct page                     cfs_page_t;
 #define CFS_PAGE_SIZE                   PAGE_CACHE_SIZE
 #define CFS_PAGE_SHIFT                  PAGE_CACHE_SHIFT
@@ -115,7 +131,7 @@ extern void __cfs_free_pages(cfs_page_t 
 #define libcfs_memory_pressure_clr() do { current->flags &= ~PF_MEMALLOC; } while (0)
 
 #if BITS_PER_LONG == 32
-/* limit to lowmem on 32-bit systems */
+/** limit to lowmem on 32-bit systems */
 #define CFS_NUM_CACHEPAGES min(num_physpages, 1UL << (30-CFS_PAGE_SHIFT) *3/4)
 #else
 #define CFS_NUM_CACHEPAGES num_physpages
@@ -142,10 +158,25 @@ extern void *cfs_mem_cache_alloc ( cfs_m
 extern void cfs_mem_cache_free ( cfs_mem_cache_t *, void *);
 extern int cfs_mem_is_in_cache(const void *addr, const cfs_mem_cache_t *kmem);
 
+/** @} libcfs_linux_mem */
+/** @} libcfs_kernel_mem */
+/** @} libcfs_mem */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
+
 /*
+ * When in-kernel user needs access to the memory mappped in
+ * user-space, the following macros may be used:
  */
 #define CFS_DECL_MMSPACE                mm_segment_t __oldfs
 #define CFS_MMSPACE_OPEN                do { __oldfs = get_fs(); set_fs(get_ds());} while(0)
 #define CFS_MMSPACE_CLOSE               set_fs(__oldfs)
 
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
+
+/** @} libcfs */
 #endif /* __LINUX_CFS_MEM_H__ */
